fixes and improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
242 export EMACSDIR=/home/iank/.iank/e/e
243 fi
244 path-add $bashrc_dir
245 fi
246 fi
247
248 # if someone exported $SOE (stop on error), catch errors.
249 #
250 # Note, on debian this results in the following warning when in ssh,
251 # hich I haven't figured out how to fix. It doesn't happen if we source
252 # after the shell has started
253 #
254 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
255 # bash: warning: cannot start debugger; debugging mode disabled
256 if [[ $SOE ]]; then
257 if [[ -e /a/bin/errhandle/err ]]; then
258 source /a/bin/errhandle/err
259 fi
260 fi
261
262
263 mysrc() {
264 local path dir file
265 path=$1
266 dir=${path%/*}
267 file=${path##*/}
268 if [[ -s $path ]]; then
269 source $path
270 elif [[ -s $bashrc_dir/$file ]]; then
271 source $bashrc_dir/$file
272 fi
273 }
274
275
276 mysrc /a/bin/small-misc-bash/ll-function
277 mysrc /a/bin/distro-functions/src/package-manager-abstractions
278
279
280 # * functions
281 ccomp() { # copy completion
282 local src=$1
283 local c
284 shift
285 if ! c=$(complete -p $src 2>/dev/null); then
286 _completion_loader $src &>/dev/null ||:
287 c=$(complete -p $src 2>/dev/null) || return 0
288 fi
289 # remove $src( .*|$)
290 c=${c% $src}
291 c=${c%% $src *}
292 eval $c $*
293 }
294
295
296 ..() { c ..; }
297 ...() { c ../..; }
298 ....() { c ../../..; }
299 .....() { c ../../../..; }
300 ......() { c ../../../../..; }
301
302 chere() {
303 local f path
304 for f; do
305 path=$(readlink -e "$f")
306 echo "cat >$path <<'EOF'"
307 cat "$f"
308 echo EOF
309 done
310 }
311
312
313 # file cut copy and paste, like the text buffers :)
314 # I havnt tested these.
315 _fbufferinit() { # internal use
316 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
317 rm -rf "${my_f_tempdir:?}"/*
318 }
319 fcp() { # file cp
320 _fbufferinit
321 cp "$@" "$my_f_tempdir"/
322 }
323 fct() { # file cut
324 _fbufferinit
325 mv "$@" "$my_f_tempdir"/
326 }
327 fpst() { # file paste
328 [[ $2 ]] && { echo too many arguments; return 1; }
329 target=${1:-.}
330 cp "$my_f_tempdir"/* "$target"
331 }
332
333 _khfix_common() {
334 local host ip port file key
335 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
336 file=$(readlink -f ~/.ssh/known_hosts)
337 if [[ ! $ip ]]; then
338 echo "khfix: ssh failed"
339 return 1
340 fi
341 if [[ $port != 22 ]]; then
342 ip_entry="[$ip]:$port"
343 host_entry="[$host]:$port"
344 else
345 ip_entry=$ip
346 host_entry=$host
347 fi
348 tmpfile=$(mktemp)
349 if [[ $host != $ip ]]; then
350 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
351 if [[ $key ]]; then
352 grep -Fv "$key" "$file" | sponge "$file"
353 fi
354 fi
355 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
356 if [[ $key ]]; then
357 grep -Fv "$key" "$file" | sponge "$file"
358 fi
359 ll ~/.ssh/known_hosts
360 rootsshsync
361 }
362 khfix() { # known hosts fix
363 _khfix_common "$@" || return 1
364 ssh $1 :
365 }
366 khcopy() {
367 _khfix_common "$@"
368 ssh-copy-id $1
369 }
370
371 a() {
372 local x
373 x=$(readlink -nf "${1:-$PWD}")
374 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
375 echo -n "$x" | xclip -selection clipboard
376 echo -n "$x" | xclip
377 }
378
379 # a1 = awk {print $1}
380 for field in {1..20}; do
381 eval a$field"() { awk '{print \$$field}'; }"
382 done
383 # h1 = head -n1
384 for num in {1..9}; do
385 eval h$num"() { head -n$num; }"
386 done
387
388
389 hexipv4() {
390 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
391 }
392
393 vp9() {
394 local f out outdir in
395 outdir=vp9
396 case $1 in
397 --out)
398 outdir=$2
399 shift 2
400 ;;
401 esac
402 m mkdir -p $outdir
403 for f; do
404 out=$PWD/$outdir/$f
405 in=$PWD/$f
406 m cd $(mktemp -d)
407 pwd
408 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
409 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
410 cd -
411 done
412 }
413
414 utcl() { # utc 24 hour time to local hour 24 hour time
415 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
416 }
417
418 declare -a _iankdirf _iankdirb
419
420
421 # ## old wcd, to be deleted
422 # b() {
423 # # backwards
424 # c -
425 # }
426 # # shellcheck disable=SC2032
427 # f() {
428 # # cd forward
429 # c +
430 # }
431 # cl() {
432 # # choose recent directory. cl = cd list
433 # c =
434 # }
435 # # c. better cd
436 # if ! type -t c &>/dev/null; then
437 # if type -p wcd &>/dev/null; then
438 # if [[ $LC_INSIDE_EMACS ]]; then
439 # c() { wcd -c -z 50 -o "$@"; }
440 # else
441 # # lets see what the fancy terminal does from time to time
442 # c() { wcd -c -z 50 "$@"; }
443 # fi
444 # else
445 # c() { cd "$@"; }
446 # fi
447 # fi
448
449 # c. better cd.
450 # keep 2 stacks, forward and back. the top of the back is $PWD
451 # as long as the last directory change was due to c,b,or cl.
452 c() {
453 # normally, the top of dirb is our current dir. if it isn't,
454 # put it on there, except we don't want to do that when we
455 # just launched a shell
456 if [[ $OLDPWD ]]; then
457 if (( ${#_iankdirb[@]} == 0 )) || [[ ${_iankdirb[-1]} != "$PWD" ]]; then
458 _iankdirb+=("$PWD")
459 fi
460 fi
461 cd "$@"
462 if (( ${#_iankdirb[@]} == 0 )) || [[ ${_iankdirb[-1]} != "$PWD" ]]; then
463 _iankdirb+=("$PWD")
464 fi
465 echo "$PWD" >> ~/.iankdirs
466 }
467 ccomp cd c
468
469 b() {
470 local topb
471 if (( ${#_iankdirb[@]} == 0 )); then
472 echo "nothing left to go back to" >&2
473 return 0
474 fi
475 topb="${_iankdirb[-1]}"
476
477 if [[ $topb == "$PWD" ]] && (( ${#_iankdirb[@]} == 1 )); then
478 echo "already on last back entry" >&2
479 return 0
480 fi
481
482
483 if [[ $topb == "$PWD" ]]; then
484 # add to dirf if not already there
485 if (( ${#_iankdirf[@]} == 0 )) || [[ ${_iankdirf[-1]} != "$topb" ]]; then
486 _iankdirf+=("$topb")
487 fi
488 unset "_iankdirb[-1]"
489 cd "${_iankdirb[-1]}"
490 else
491 if (( ${#_iankdirf[@]} == 0 )) || [[ ${_iankdirf[-1]} != "$PWD" ]]; then
492 _iankdirf+=("$PWD")
493 fi
494 cd "$topb"
495 fi
496
497 # give us a peek at what is next in the list
498 # if (( ${#_iankdirb[@]} >= 2 )); then
499 # printf "%s\n" "${_iankdirb[-2]}"
500 # fi
501 }
502
503 f() {
504 local topf
505 if (( ${#_iankdirf[@]} == 0 )); then
506 echo "no forward dir left" >&2
507 return 0
508 fi
509 topf="${_iankdirf[-1]}"
510 unset "_iankdirf[-1]"
511 c "$topf"
512
513 # give us a peek at what is next in the list
514 # if (( ${#_iankdirf[@]} )); then
515 # printf "%s\n" "${_iankdirf[-1]}"
516 # fi
517 }
518
519 # a b c (d)
520 ## back
521 # a b (c)
522 # d
523 #back
524 #a (b)
525 #d c
526 #back
527 #(a)
528 #d c b
529 #forward
530 #a (b)
531 #d c
532 #
533 # a b c
534 ## back
535 # a b
536 # (c)
537 ## forward
538
539 cl() {
540 local i line input start tmpfile
541 local -A buttondirs alines
542 local -a buttons dirs lines
543 buttons=( {a..z} {2..9} )
544 if [[ ! -s ~/.iankdirs ]]; then
545 echo nothing in ~/.iankdirs
546 return 0
547 fi
548
549 i=0
550
551 # note, alternate approach like this, made the following read fail
552 # done < <(tac ~/.iankdirs | awk '!seen[$0]++')
553 # bash: read: read error: 0: Input/output error
554 # which went away by adding a sleep 1 after it.
555
556 mapfile -t lines <~/.iankdirs
557 start=$(( ${#lines[@]} - 1 ))
558
559 # we have ~33 buttons as of this writing, so lets
560 # prune down the history every once in a while.
561 if (( start > 500 )); then
562 tmpfile=$(mktemp)
563 tac ~/.iankdirs | awk '!seen[$0]++' | head -n 200 >$tmpfile
564 cat $tmpfile > ~/.iankdirs
565 fi
566
567 for (( j=$start; j >= 0; j-- )); do
568 line="${lines[$j]}"
569 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
570 continue
571 fi
572 alines[$line]=t
573 buttondirs[${buttons[i]}]="$line"
574 printf "%s %s\n" ${buttons[i]} "$line"
575 if (( i == ${#buttons[@]} - 1 )); then
576 break
577 fi
578 i=$(( i + 1 ))
579 done
580
581 if (( i == 0 )); then
582 echo "no dirs in ~/.iankdirs"
583 return 0
584 fi
585 read -r -N 1 input
586 if [[ $input != $'\n' ]]; then
587 c ${buttondirs[$input]}
588 fi
589 }
590 bl() {
591 local start i j max
592 max=10
593 start=$(( ${#_iankdirb[@]} - 1 ))
594
595 # cleanup possible repeating of pwd
596 if (( start >= 0 )) && [[ ${_iankdirb[$start]} == "$PWD" ]]; then
597 start=$(( start - 1 ))
598 fi
599 j=1
600 if (( start >= 0 )); then
601 for (( i=$start; i >= 0 ; i-- )); do
602 printf "%s %s\n" $j ${_iankdirb[i]}
603 j=$(( j + 1 ))
604 if (( j >= max )); then
605 break
606 fi
607 done
608 fi
609
610 max=10
611
612 start=$(( ${#_iankdirf[@]} - 1 ))
613
614 # cleanup possible repeating of pwd
615 if (( start >= 0 )) && [[ ${_iankdirf[$start]} == "$PWD" ]]; then
616 start=$(( start - 1 ))
617 fi
618 if (( start < 0 )); then
619 return 0
620 fi
621 echo --
622 j=1
623 for (( i=$start; i >= 0 ; i-- )); do
624 printf "%s %s\n" $j ${_iankdirf[i]}
625 j=$(( j + 1 ))
626 if (( j >= max )); then
627 break
628 fi
629 done
630 }
631
632
633
634 c4() { c /var/log/exim4; }
635
636 caa() { git commit --amend --no-edit -a; }
637
638 cf() {
639 for f; do
640 hr
641 echo "$f"
642 hr
643 cat "$f"
644 done
645 }
646 caf() {
647 # shellcheck disable=SC2033
648 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
649 -o -name .hg -prune -o -name .editor-backups -prune \
650 -o -name .undo-tree-history -prune \) \
651 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
652
653 }
654 ccomp cat cf caf
655
656 calc() { echo "scale=3; $*" | bc -l; }
657 # no having to type quotes, but also no command history:
658 clc() {
659 local x
660 read -r x
661 echo "scale=3; $x" | bc -l
662 }
663
664 cam() {
665 git commit -am "$*"
666 }
667
668 ccat () { # config cat. see a config without extra lines.
669 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
670 }
671 ccomp grep ccat
672
673 chrbind() {
674 local d
675 # dev/pts needed for pacman signature check
676 for d in dev proc sys dev/pts; do
677 [[ -d $d ]]
678 if ! mountpoint $d &>/dev/null; then
679 m s mount -o bind /$d $d
680 fi
681 done
682 }
683 chumount() {
684 local d
685 # dev/pts needed for pacman signature check
686 for d in dev/pts dev proc sys; do
687 [[ -d $d ]]
688 if mountpoint $d &>/dev/null; then
689 m s umount $d
690 fi
691 done
692 }
693
694
695 _cdiff-prep() {
696 # join options which are continued to multiples lines onto one line
697 local first=true
698 while IFS= read -r line; do
699 # remove leading spaces/tabs. assumes extglob
700 if [[ $line == "[ ]*" ]]; then
701 line="${line##+( )}"
702 fi
703 if $first; then
704 pastline="$line"
705 first=false
706 elif [[ $line == *=* ]]; then
707 echo "$pastline" >> "$2"
708 pastline="$line"
709 else
710 pastline="$pastline $line"
711 fi
712 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
713 echo "$pastline" >> "$2"
714 }
715
716 cdiff() {
717 # diff config files,
718 # setup for format of postfix, eg:
719 # option = stuff[,]
720 # [more stuff]
721 local pastline unified f1 f2
722 unified="$(mktemp)"
723 f1="$(mktemp)"
724 f2="$(mktemp)"
725 _cdiff-prep "$1" "$f1"
726 _cdiff-prep "$2" "$f2"
727 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
728 while IFS= read -r line; do
729 # the default bright red / blue doesnt work in emacs shell
730 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
731 done < "$unified"
732 }
733
734
735 cat-new-files() {
736 local start=$SECONDS
737 local dir="$1"
738 # shellcheck disable=SC2030
739 inotifywait -m "$dir" -e create -e moved_to | \
740 while read -r filedir _ file; do
741 cat "$filedir$file"
742 hr
743 calc $((SECONDS - start)) / 60
744 sleep 5
745 done
746
747 }
748
749 # shellcheck disable=SC2032
750 chown() {
751 # makes it so chown -R symlink affects the symlink and its target.
752 if [[ $1 == -R ]]; then
753 shift
754 command chown -h "$@"
755 command chown -R "$@"
756 else
757 command chown "$@"
758 fi
759 }
760
761 cim() {
762 git commit -m "$*"
763 }
764
765
766 d() { builtin bg "$@"; }
767 ccomp bg d
768
769 dc() {
770 diff --strip-trailing-cr -w "$@" # diff content
771 }
772 ccomp diff dc
773
774 despace() {
775 local x y
776 for x in "$@"; do
777 y="${x// /_}"
778 safe_rename "$x" "$y"
779 done
780 }
781
782 # get ipv4 ip from HOST. or if it is already a number, return that
783 hostip() {
784 local host="$1"
785 case $host in
786 [0-9:])
787 echo "$host"
788 ;;
789 *)
790 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
791 ;;
792 esac
793 }
794
795 dig() {
796 command dig +nostats +nocmd "$@"
797 }
798 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
799 digsort() {
800 local sec
801 sec=
802 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
803 if [[ $l == [^\;]* ]]; then
804 sec+="$l"$'\n'
805 else
806 if [[ $sec ]]; then
807 printf "%s" "$sec" | sort
808 sec=
809 fi
810 printf "%s\n" "$l"
811 fi
812 done
813 }
814 ccomp dig digsort
815 # compare digs to the 2 servers
816 # usage: digdiff @server1 @server2 DIG_ARGS
817 # note: only the soa master nameserver will respond with
818 # ra "recursive answer" flag. That difference is meaningless afaik.
819 digdiff() {
820 local s1 s2
821 s1=$1
822 shift
823 s2=$1
824 shift
825 digsort $s1 "$@" | tee /tmp/digdiff
826 diff -u /tmp/digdiff <(digsort $s2 "$@")
827 }
828
829 dt() {
830 date "+%A, %B %d, %r" "$@"
831 }
832 dtr() {
833 date -R "$@"
834 }
835 ccomp date dt dtr
836
837 dus() { # du, sorted, default arg of
838 du -sh ${@:-*} | sort -h
839 }
840 ccomp du dus
841
842
843 e() { printf "%s\n" "$*"; }
844
845 # echo args
846 ea() {
847 if (( ! $# )); then
848 echo no args
849 fi
850 for arg; do
851 printf "%qEOL\n" "${arg}"
852 printf "%s" "${arg}" |& hexdump -C
853 done
854 }
855 # echo vars. print var including escapes, etc
856 ev() {
857 if (( ! $# )); then
858 echo no args
859 fi
860 for arg; do
861 if [[ -v $arg ]]; then
862 printf "%qEOL\n" "${!arg}"
863 printf "%s" "${!arg}" |& hexdump -C
864 else
865 echo arg $arg is unset
866 fi
867 done
868 }
869
870 ediff() {
871 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
872 emacs --eval "(ediff-files \"$1\" \"$2\")"
873 }
874
875 # mail related
876 etail() {
877 tail -F /var/log/exim4/mainlog -n 200 "$@"
878 }
879 etail2() {
880 tail -F /var/log/exim4/mymain -n 200 "$@"
881 }
882
883 ccomp tail etail etail2
884
885 # print exim old pids
886 eoldpids() {
887 local configtime pid piduptime now daemonpid
888 printf -v now '%(%s)T' -1
889 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
890 if [[ -s /run/exim4/exim.pid ]]; then
891 daemonpid=$(cat /run/exim4/exim.pid)
892 fi
893 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
894 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
895 if [[ $pid == $daemonpid ]]; then
896 continue
897 fi
898 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
899 if (( configtime > now - piduptime )); then
900 echo $pid
901 fi
902 done
903 }
904
905 # exim tail but only watch lines from new pids
906 etailnew() {
907 local pid oldpids
908 for pid in $(eoldpids); do
909 oldpids+="$pid|"
910 done
911 if [[ $oldpids ]]; then
912 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
913 else
914 etail
915 fi
916 }
917 # exim watch as old pids go away
918 ewatchold() {
919 local configtime pid piduptime now
920 local -i count
921 local -a oldpids
922 count=0
923 while true; do
924 oldpids=($(eoldpids))
925 if (( ! ${#oldpids[@]} )); then
926 return
927 fi
928 # print the date every 20 iterations
929 if (( ! count % 20 )); then
930 date
931 fi
932 count+=1
933 ps -f -p "${oldpids[*]}"
934 sleep 1
935 done
936 }
937
938 eless() {
939 less /var/log/exim4/mainlog
940 }
941 ccomp less eless
942 eqcat() {
943 exiqgrep -i -o 60 | while read -r i; do
944 hlm exim -Mvc $i
945 echo
946 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
947 done
948 }
949 eqrmf() {
950 exiqgrep -i | xargs exim -Mrm
951 }
952
953 econfdevnew() {
954 rm -rf /tmp/edev
955 mkdir -p /tmp/edev/etc
956 cp -ra /etc/exim4 /tmp/edev/etc
957 cp -ra /etc/alias* /tmp/edev/etc
958 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
959 econfdev
960 }
961 econfdev() {
962 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
963 }
964
965
966
967
968 fa() {
969 # find array. make an array of file names found by find into $x
970 # argument: find arguments
971 # return: find results in an array $x
972 while read -rd ''; do
973 x+=("$REPLY");
974 done < <(find "$@" -print0);
975 }
976
977 faf() { # find all files. use -L to follow symlinks
978 find "$@" -not \( -name .svn -prune -o -name .git -prune \
979 -o -name .hg -prune -o -name .editor-backups -prune \
980 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
981 }
982
983 # full path without resolving symlinks
984 fp() {
985 local dir base
986 base="${1##*/}"
987 dir="${1%$base}"
988 printf "%s/%s\n" $(cd $dir; pwd) "$base"
989 }
990
991
992 # mail related
993 frozen() {
994 rm -rf /tmp/frozen
995 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
996 sudo exim -Mvl $id
997 echo
998 sudo exim -Mvh $id
999 echo
1000 sudo exim -Mvb $id
1001 echo -e '\n\n##############################\n'
1002 done | tee -a /tmp/frozen
1003 }
1004 frozenrm() {
1005 local ids=()
1006 while read -r line; do
1007 printf '%s\n' "$line"
1008 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
1009 done < <(s mailq)
1010 echo "sleeping for 2 in case you change your mind"
1011 sleep 2
1012 sudo exim -Mrm "${ids[@]}"
1013 }
1014
1015 funce() {
1016 # like -e for functions. returns on error.
1017 # at the end of the function, disable with:
1018 # trap ERR
1019 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1020 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1021 trap ERR
1022 return' ERR
1023 }
1024
1025 getdir () {
1026 local help="Usage: getdir [--help] PATH
1027 Output the directory of PATH, or just PATH if it is a directory."
1028 if [[ $1 == --help ]]; then
1029 echo "$help"
1030 return 0
1031 fi
1032 if [[ $# -ne 1 ]]; then
1033 echo "getdir error: expected 1 argument, got $#"
1034 return 1
1035 fi
1036 if [[ -d $1 ]]; then
1037 echo "$1"
1038 else
1039 local dir
1040 dir="$(dirname "$1")"
1041 if [[ -d $dir ]]; then
1042 echo "$dir"
1043 else
1044 echo "getdir error: directory does not exist"
1045 return 1
1046 fi
1047 fi
1048 }
1049
1050 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1051 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1052 local root
1053 root=$(gitroot) || return 1 # function to set gitroot
1054 builtin cd "$root"
1055 git symbolic-ref HEAD refs/heads/$1
1056 rm .git/index
1057 git clean -fdx
1058 }
1059
1060 # shellcheck disable=SC2120
1061 gitroot() {
1062 local help="Usage: gitroot [--help]
1063 Print the full path to the root of the current git repo
1064
1065 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1066 and works in older versions of git which did not have that."
1067 if [[ $1 == --help ]]; then
1068 echo "$help"
1069 return
1070 fi
1071 local p
1072 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1073 [[ $p != /* ]] && p=$PWD
1074 echo "${p%%/.git}"
1075 }
1076
1077 g() {
1078
1079 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1080 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1081
1082 local args gdb=false
1083
1084 if [[ $EMACSDIR ]]; then
1085 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1086 fi
1087
1088 if [[ $DISPLAY ]]; then
1089 args=-n
1090 fi
1091
1092 if (( $# == 0 )); then
1093 args+=" -c"
1094 fi
1095 # duplicate -c, but oh well
1096 if ! pgrep -u $EUID emacsclient; then
1097 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1098 gdb=true
1099 else
1100 args+=" -c"
1101 fi
1102 fi
1103 if [[ $EMACSDIR ]]; then
1104 # Alter the path here, otherwise the nfs mount gets triggered on the
1105 # first path lookup when emacs is not being used.
1106 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1107 else
1108 if $gdb; then
1109 # due to a bug, we cant debug from the start unless we get a new gdb
1110 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1111 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1112 m emacsclient -a "" $args "$@"
1113 sleep 1
1114 cd /a/opt/emacs-$(distro-name)$(distro-num)
1115 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
1116 cd -
1117 else
1118 m emacsclient -a "" $args "$@"
1119 fi
1120 fi
1121 }
1122
1123 # force terminal version
1124 gn() {
1125 g -n "$@"
1126 }
1127
1128 gmacs() {
1129 # quit will prompt if the program crashes.
1130 gdb -ex=r -ex=quit --args emacs "$@"; r;
1131 }
1132
1133 gdkill() {
1134 # kill the emacs daemon
1135 pk1 emacs --daemon
1136 }
1137
1138 gr() {
1139 grep -iIP --color=auto "$@" || return $?
1140 }
1141 grr() { # grep recursive
1142 # Don't return 1 on nonmatch because this is meant to be
1143 # interactive, not in a conditional.
1144 if [[ ${#@} == 1 ]]; then
1145 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1146 else
1147 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1148 fi
1149 }
1150 ccomp grep gr grr
1151
1152 rg() { grr "$@"; }
1153 ccomp grep rg
1154
1155 hr() { # horizontal row. used to break up output
1156 printf "$(tput setaf 5 2>/dev/null ||:)â–ˆ$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
1157 echo
1158 }
1159 # highlight
1160 hl() {
1161 local col input_len=0
1162 for arg; do
1163 input_len=$((input_len + 1 + ${#arg}))
1164 done
1165 col=$((60 - input_len))
1166 printf "\e[1;97;41m%s" "$*"
1167 if (( col > 0 )); then
1168 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1169 fi
1170 echo
1171 }
1172 hlm() { hl "$*"; "$@"; }
1173
1174 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1175
1176
1177 # get latest hub and run it
1178 # main command to use:
1179 # hub pull-request --no-edit
1180 # --no-edit means to use the first commit\'s message as the pull request message.
1181 # If that fails, try doing
1182 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1183 # where branch is usually master. it does the pr against your current branch.
1184 #
1185 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1186 # it\'s at ~/.config/hub
1187 hub() {
1188 local up uptar updir p
1189 p=/github/hub/releases/
1190 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
1191 uptar=${up##*/}
1192 updir=${uptar%.tgz}
1193 if [[ ! -e /a/opt/$updir ]]; then
1194 rm -rf /a/opt/hub-linux-amd64*
1195 wget -P /a/opt $up
1196 tar -C /a/opt -zxf /a/opt/$uptar
1197 rm -f /a/opt/$uptar
1198 fi
1199 if ! which hub &>/dev/null; then
1200 sudo /a/opt/$updir/install
1201 fi
1202
1203 # save token across computers
1204 if [[ ! -L ~/.config/hub ]]; then
1205 if [[ -e ~/.config/hub ]]; then
1206 mv ~/.config/hub /p/c/subdir_files/.config/
1207 fi
1208 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1209 conflink
1210 fi
1211 fi
1212 command hub "$@"
1213 }
1214
1215 i() { git "$@"; }
1216 ccomp git i
1217
1218 ic() {
1219 # fast commit all
1220 git commit -am "$*"
1221 }
1222
1223 ipp() {
1224 git pull
1225 git push
1226 }
1227
1228
1229 ifn() {
1230 # insensitive find
1231 find -L . -not \( -name .svn -prune -o -name .git -prune \
1232 -o -name .hg -prune -o -name .editor-backups -prune \
1233 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1234 }
1235
1236 ifd() {
1237 # insensitive find directory
1238 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1239 -o -name .hg -prune -o -name .editor-backups -prune \
1240 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1241 }
1242
1243
1244 ipdrop() {
1245 sudo iptables -A INPUT -s $1 -j DROP
1246 }
1247
1248
1249 istext() {
1250 grep -Il "" "$@" &>/dev/null
1251 }
1252
1253 jtail() {
1254 journalctl -n 10000 -f "$@"
1255 }
1256 jr() { journalctl "$@" ; }
1257 jrf() { journalctl -f "$@" ; }
1258 jru() {
1259 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1260 }
1261
1262 l() {
1263 if [[ $PWD == /[iap] ]]; then
1264 command ls -A --color=auto -I lost+found "$@"
1265 else
1266 command ls -A --color=auto "$@"
1267 fi
1268 }
1269
1270 lcn() { locate -i "*$**"; }
1271
1272 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1273
1274 lt() { ll -tr "$@"; }
1275
1276 lld() { ll -d "$@"; }
1277
1278 ccomp ls l lg lt lld ll
1279
1280 # low recursively
1281 lowr() {
1282 local f dirs i a
1283 local -a all
1284 for dirs in false true; do
1285 for f; do
1286 if [[ -d $f ]]; then
1287 all=("$f"/**)
1288 # reverse the order to rename the nested dirs first.
1289 # note: 0 element is the dir itself
1290 for ((i=${#all[@]}-1; i>=1; i--)); do
1291 a="${all[i]}"
1292 if $dirs && [[ -d $a ]]; then
1293 # e dirs low "$a" # debug
1294 low "$a"
1295 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1296 # debug
1297 # e not dirs low "$a" # debug
1298 low "$a"
1299 fi
1300 done
1301 fi
1302 # just rename all the top level args on the second pass
1303 if $dirs; then
1304 # e final dirs low "$f" # debug
1305 low "$f"
1306 fi
1307 done
1308 done
1309 }
1310
1311 low() { # make filenames lowercase, remove bad chars
1312 local arg new dir f
1313 for arg; do
1314 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1315 dir="${arg%/*}"
1316 if (( ${#dir} == ${#arg} )); then
1317 dir=.
1318 fi
1319 f="${arg##*/}"
1320 new="${f,,}" # downcase
1321 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1322 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1323 new="${new%"${new##*[[:alnum:]]}"}"
1324 # remove bad underscores, like __ and _._
1325 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1326 safe_rename "$dir/$f" "$dir/$new" || return 1
1327 done
1328 return 0
1329 }
1330
1331 lower() { # make first letter of filenames lowercase.
1332 local x
1333 for x in "$@"; do
1334 if [[ ${x::1} == [A-Z] ]]; then
1335 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1336 safe_rename "$x" "$y" || return 1
1337 fi
1338 done
1339 }
1340
1341
1342 k() { # history search
1343 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1344 }
1345 ks() { # history search with context
1346 # args are an extended regex used by sed
1347 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1348 }
1349 ksu() { # history search unique
1350 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1351 }
1352
1353 # todo: id like to do maybe a daily or hourly cronjob to
1354 # check that my history file size is increasing. Ive had it
1355 # inexplicably truncated in the past.
1356 histrm() {
1357 history -n
1358 HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1359 read -p "press anything but contrl-c to delete"
1360 for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1361 history -d $entry
1362 done
1363 history -w
1364 }
1365
1366 ccomp grep k ks ksu histrm
1367
1368
1369 make-targets() {
1370 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1371 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1372 }
1373
1374 mkc() {
1375 mkdir "$1"
1376 c "$1"
1377 }
1378 ccomp mkdir mkc
1379
1380 mkct() {
1381 mkc $(mktemp -d)
1382 }
1383
1384 mkt() { # mkdir and touch file
1385 local path="$1"
1386 mkdir -p "$(dirname "$path")"
1387 touch "$path"
1388 }
1389
1390 # shellcheck disable=SC2032
1391 mkdir() { command mkdir -p "$@"; }
1392
1393 nags() {
1394 # https://github.com/HenriWahl/Nagstamon/issues/357
1395 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1396 /usr/lib/notification-daemon/notification-daemon &
1397 fi
1398 /usr/bin/nagstamon &
1399 }
1400
1401 nmt() {
1402 s nmtui-connect "$@"
1403 }
1404
1405 nopanic() {
1406 # shellcheck disable=SC2024
1407 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1408 }
1409
1410 p8() { ping "$@" 8.8.8.8; }
1411 p6() { ping6 "$@" 2001:4860:4860::8888; }
1412
1413 pkx() { # package extract
1414 local pkg cached tmp f
1415 c $(mktemp -d)
1416 pkg=$1
1417 # shellcheck disable=SC2012
1418 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1419 if [[ $cached ]]; then
1420 cp $cached .
1421 else
1422 aptitude download $pkg || return 1
1423 fi
1424 tmp=(*); f=${tmp[0]} # only 1 expected
1425 ex $f
1426 rm -f $f
1427 }
1428
1429 # pgrep and kill
1430 pk1() {
1431 local pid
1432 pid=($(pgrep -f "$*"))
1433 case ${#pid[@]} in
1434 1)
1435 # shellcheck disable=SC2128
1436 {
1437 ps -F $pid
1438 m kill $pid
1439 }
1440 ;;
1441 0) echo "no pid found" ;;
1442 *)
1443 ps -F ${pid[@]}
1444 ;;
1445 esac
1446 }
1447
1448 psg () {
1449 local x y help
1450 help="Usage: psg [--help] GREP_ARGS
1451 grep ps and output in a nice format"
1452 if [[ $1 == --help ]]; then
1453 echo "$help"
1454 return
1455 fi
1456 x=$(ps -eF)
1457 # final grep is because some commands tend to have a lot of trailing spaces
1458 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1459 if [[ $y ]]; then
1460 echo "$x" | head -n 1 || [[ $? == 141 ]]
1461 echo "$y"
1462 fi
1463 }
1464
1465 pubip() { curl -4s https://icanhazip.com; }
1466 pubip6() { curl -6s https://icanhazip.com; }
1467 whatismyip() { pubip; }
1468
1469
1470 q() { # start / launch a program in the backround and redir output to null
1471 "$@" &> /dev/null &
1472 }
1473
1474 # shellcheck disable=SC2120
1475 r() {
1476 if [[ $HISTFILE ]]; then
1477 history -a # save history
1478 fi
1479 trap ERR # this avoids a segfault
1480 exit ${1:0}
1481 # i had this redir, not sure why
1482 # exit "$@" 2>/dev/null
1483 }
1484
1485 # scp is insecure and deprecated.
1486 scp() {
1487 rsync --inplace "$@"
1488 }
1489
1490 randport() {
1491 # available high ports are 1024-65535,
1492 # but lets skip things that are more likely to be in use
1493 python3 <<'EOF'
1494 import secrets
1495 print(secrets.SystemRandom().randrange(10002,65500))
1496 EOF
1497 }
1498
1499 # reapply bashrc
1500 reb() {
1501 source ~/.bashrc
1502 }
1503
1504 rl() {
1505 readlink -f "$@"
1506 }
1507 ccomp readlink rl
1508
1509 rsd() {
1510 # rsync, root is required to keep permissions right.
1511 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1512 # --no-times --delete
1513 # basically, make an exact copy, use checksums instead of file times to be more accurate
1514 rsync -ahvic --delete "$@"
1515 }
1516 rsa() {
1517 # like rlu, but dont delete files on the target end which
1518 # do not exist on the original end.
1519 rsync -ahvic "$@"
1520 }
1521 rst() {
1522 # rl without preserving modification time.
1523 rsync -ahvic --delete --no-t "$@"
1524 }
1525 rsu() { # [OPTS] HOST PATH
1526 # eg. rlu -opts frodo /testpath
1527 # relative paths will expanded with readlink -f.
1528 opts=("${@:1:$#-2}") # 1 to last -2
1529 path="${*:$#}" # last
1530 host="${*:$#-1:1}" # last -1
1531 if [[ $path == .* ]]; then
1532 path=$(readlink -f $path)
1533 fi
1534 # rync here uses checksum instead of time so we dont mess with
1535 # unison relying on time as much. g is for group, same reason
1536 # to keep up with unison.
1537 m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1538 }
1539 ccomp rsync rsd rsa rst rsu
1540
1541 # find programs listening on a port
1542 ssp() {
1543 local port=$1
1544 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1545 s ss -lpn state listening sport = $port
1546 }
1547
1548 resolvcat() {
1549 local f
1550 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1551 m s nscd -i hosts
1552 fi
1553 f=/etc/resolv.conf
1554 echo $f:; ccat $f
1555 hr; s ss -lpn sport = 53
1556 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1557 # this will fail is dnsmasq is failed
1558 hr; m ser status dnsmasq | cat || :
1559 f=/etc/dnsmasq.conf
1560 hr; echo $f:; ccat $f
1561 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1562 f=/etc/dnsmasq-servers.conf
1563 hr; echo $f:; ccat $f
1564 fi
1565 hr
1566 echo /etc/nsswitch.conf:
1567 grep '^ *hosts:' /etc/nsswitch.conf
1568 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1569 hr; m ser status systemd-resolved | cat || :
1570 hr; m systemd-resolve --status | cat
1571 fi
1572
1573 }
1574 rcat() {
1575 resolvcat | less
1576 }
1577 reresolv() {
1578 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1579 m ser stop nscd
1580 sleep .5
1581 m ser start nscd
1582 m sudo nscd -i hosts
1583 fi
1584 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1585 m sudo systemctl restart dnsmasq
1586 fi
1587 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1588 m sudo systemctl restart systemd-resolved
1589 fi
1590 if type -P resolvectl &>/dev/null; then
1591 resolvectl flush-caches
1592 fi
1593 }
1594
1595 rmstrips() {
1596 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1597 }
1598
1599 sudo () {
1600 command sudo "$@" || return $?
1601 DID_SUDO=true
1602 }
1603 s() {
1604 # background
1605 # I use a function because otherwise we cant use in a script,
1606 # cant assign to variable.
1607 #
1608 # note: gksudo is recommended for X apps because it does not set the
1609 # home directory to the same, and thus apps writing to ~ fuck things up
1610 # with root owned files.
1611 #
1612 if [[ $EUID != 0 || $1 == -* ]]; then
1613 # shellcheck disable=SC2034
1614 SUDOD="$PWD" command sudo -i "$@"
1615 DID_SUDO=true
1616 else
1617 "$@"
1618 fi
1619 }
1620 sb() { # sudo bash -c
1621 # use sb instead of s is for sudo redirections,
1622 # eg. sb 'echo "ok fine" > /etc/file'
1623 # shellcheck disable=SC2034
1624 local SUDOD="$PWD"
1625 sudo -i bash -c "$@"
1626 }
1627 ccomp sudo s sb
1628
1629 safe_rename() { # warn and dont rename if file exists.
1630 # mv -n exists, but it\'s silent
1631 if [[ $# != 2 ]]; then
1632 echo safe_rename error: $# args, need 2 >2
1633 return 1
1634 fi
1635 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1636 if [[ -e $2 || -L $2 ]]; then
1637 echo "Cannot rename $1 to $2 as it already exists."
1638 else
1639 mv -vi "$1" "$2"
1640 fi
1641 fi
1642 }
1643
1644
1645 sd() {
1646 sudo dd status=none of="$1"
1647 }
1648
1649 ser() {
1650 if type -p systemctl &>/dev/null; then
1651 s systemctl "$@"
1652 else
1653 if (( $# >= 3 )); then
1654 echo iank: ser expected 2 or less arguments
1655 return 1
1656 fi
1657 s service $2 $1
1658 fi
1659 }
1660 serstat() {
1661 systemctl -n 40 status "$@"
1662 }
1663
1664 seru() { systemctl --user "$@"; }
1665 # like restart, but do nothing if its not already started
1666 srestart() {
1667 local service=$1
1668 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1669 systemctl restart $service
1670 fi
1671 }
1672
1673 setini() { # set a value in a .ini style file
1674 key="$1" value="$2" section="$3" file="$4"
1675 if [[ -s $file ]]; then
1676 sed -ri -f - "$file" <<EOF
1677 # remove existing keys
1678 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1679 # add key
1680 /^\s*\[$section\]/a $key=$value
1681 # from section to eof, do nothing
1682 /^\s*\[$section\]/,\$b
1683 # on the last line, if we haven't found section yet, add section and key
1684 \$a [$section]\\
1685 $key=$value
1686 EOF
1687 else
1688 cat >"$file" <<EOF
1689 [$section]
1690 $key=$value
1691 EOF
1692 fi
1693 }
1694
1695 sgo() { # service go
1696 service=$1
1697 ser restart $service || return 1
1698 if type -p systemctl &>/dev/null; then
1699 ser enable $service
1700 fi
1701 }
1702 soff () {
1703 for service; do
1704 # ignore services that dont exist
1705 if systemctl cat $service &>/dev/null; then
1706 ser stop $service;
1707 ser disable $service
1708 fi
1709 done
1710 }
1711
1712 sgu() {
1713 systemctl list-unit-files | rg "$@"
1714 }
1715
1716
1717 sk() {
1718
1719
1720 # disable a warning with:
1721 # shellcheck disable=SC2206 # reasoning
1722
1723 # see bash-template/style-guide.md for justifications
1724
1725 local quotes others
1726 quotes=2048,2068,2086,2206
1727 others=2029,2033,2164
1728 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
1729 }
1730
1731
1732 # sl: ssh, but firsh rsync our bashrc and related files to a special
1733 # directory on the remote host if needed.
1734
1735 # Some environment variables and files need to be setup for this to work
1736 # (mine are set at the beginning of this file)
1737
1738 # SL_FILES_DIR: Environment variable. Path to folder which should at
1739 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1740 # remote hosts (top level symlinks are resolved) unless the host already
1741 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1742 # control and sync files to separately and already has the ~/.bashrc you
1743 # want. The remote bash will also take its .inputrc config from this
1744 # folder (default of not existing is fine). Mine looks like this:
1745 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1746
1747 # SL_INFO_DIR: Environment variable. This folder stores info about what
1748 # we detected on the remote system and when we last synced. It will be created
1749 # if it does not exist. Sometimes you may want to forget about a
1750 # remote system, you can use sl --rsync, or the function for that slr
1751 # below.
1752
1753 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1754 # depending on the remote host. Run this string on the remote host the
1755 # first time sl is run (or if we run slr). The result is passed to
1756 # SL_TEST_HOOK. For example,
1757 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1758
1759 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1760 # $SL_FILES_DIR to vary the files synced.
1761
1762 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1763 # example to exclude files within a directory. Note, excluded
1764 # files wont be deleted on rsync, you can add --delete-excluded
1765 # to the rsync command if that is desired.
1766
1767 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1768
1769 # For when ~/.bashrc is already customized on the remote server, you
1770 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1771 # commands, even in scripts. This paragraph is all about that. bash
1772 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1773 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1774 # and if you customize it, probably has bugs from time to time. This is
1775 # bad. Here's how I fix it. I have a special condition to "return" in my
1776 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1777 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1778 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1779 # separate file because even if I return early on, the whole file gets
1780 # parsed which can fail if there is a syntax error.
1781 sl() {
1782 # Background on LC_USEBASHRC var (no need to read if you just want to
1783 # use this function): env variables sent across ssh are strictly
1784 # limited, but we get LC_* at least in debian based machines, so we
1785 # just make that * be something no normal program would use. Note, on
1786 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1787 # set, and the inner shell also allows running a nondefault
1788 # .bashrc. This means the outer shell still ran the default .bashrc,
1789 # but that is the best we can do.
1790
1791 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1792 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1793 declare -a args tmpa
1794
1795 args=($SL_SSH_ARGS)
1796
1797 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1798 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1799 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1800 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1801 # [command]
1802
1803 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1804 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1805 # [-F configfile] [-I pkcs11] [-i identity_file]
1806 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1807 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1808 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1809
1810 force_rsync=false
1811 if [[ $1 == --rsync ]]; then
1812 force_rsync=true
1813 shift
1814 fi
1815
1816 sl_test_cmd=$SL_TEST_CMD
1817 sl_test_hook=$SL_TEST_HOOK
1818 sl_rsync_args=$SL_RSYNC_ARGS
1819 while [[ $1 ]]; do
1820 case "$1" in
1821 --rsync)
1822 force_rsync=true
1823 ;;
1824 --sl-test-cmd)
1825 sl_test_cmd="$2"
1826 shift
1827 ;;
1828 --sl-test-hook)
1829 sl_test_hook="$2"
1830 shift
1831 ;;
1832 --sl-rsync-args)
1833 sl_rsync_args="$2"
1834 shift
1835 ;;
1836 *)
1837 break
1838 ;;
1839 esac
1840 shift
1841 done
1842
1843 while [[ $1 ]]; do
1844 case "$1" in
1845 # note we dont support things like -4oOption
1846 -[46AaCfGgKkMNnqsTtVvXxYy]*)
1847 args+=("$1"); shift
1848 ;;
1849 -[bcDEeFIiJLlmOopQRSWw]*)
1850 # -oOption etc is valid
1851 if (( ${#1} >= 3 )); then
1852 args+=("$1"); shift
1853 else
1854 args+=("$1" "$2"); shift 2
1855 fi
1856 ;;
1857 *)
1858 break
1859 ;;
1860 esac
1861 done
1862 remote="$1"
1863 if [[ ! $remote ]]; then
1864 echo $0: error hostname required >&2
1865 return 1
1866 fi
1867 shift
1868
1869 if [[ ! $SL_INFO_DIR ]]; then
1870 echo error: missing '$SL_INFO_DIR' env var >&2
1871 return 1
1872 fi
1873
1874 dorsync=false
1875 haveinfo=false
1876 tmpa=($SL_INFO_DIR/???????????"$remote")
1877 sshinfo=${tmpa[0]}
1878 if [[ -e $sshinfo ]]; then
1879 if $force_rsync; then
1880 rm -f $sshinfo
1881 else
1882 haveinfo=true
1883 fi
1884 fi
1885 if $haveinfo; then
1886 tmp=${sshinfo[0]##*/}
1887 tmp2=${tmp::11}
1888 type=${tmp2: -1}
1889 extra_info=$(cat $sshinfo)
1890 else
1891 # we test for string to know ssh succeeded
1892 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
1893 testcmd="if $testbool; then printf y; else printf n; fi"
1894 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
1895 echo failed sl test. doing plain ssh -v
1896 command ssh -v "${args[@]}" "$remote"
1897 fi
1898 if [[ $tmp == y* ]]; then
1899 type=a
1900 else
1901 dorsync=true
1902 type=b
1903 fi
1904 extra_info="${tmp:1}"
1905 fi
1906 if [[ $sl_test_hook ]]; then
1907 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
1908 fi
1909
1910 if $haveinfo && [[ $type == b ]]; then
1911 info_sec=${tmp::10}
1912 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
1913 files_sec=${files_sec%%.*}
1914 if (( files_sec > info_sec )); then
1915 dorsync=true
1916 rm -f $sshinfo
1917 fi
1918 fi
1919
1920 sync_dirname=${SL_FILES_DIR##*/}
1921
1922 if [[ ! $SL_FILES_DIR ]]; then
1923 echo error: missing '$SL_FILES_DIR' env var >&2
1924 return 1
1925 fi
1926
1927 if $dorsync; then
1928 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
1929 fi
1930 if $dorsync || ! $haveinfo; then
1931 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
1932 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
1933 printf "%s\n" "$extra_info" >$sshinfo
1934 chmod 666 $sshinfo
1935 fi
1936 if [[ $type == b ]]; then
1937 if (( ${#@} )); then
1938 # Theres a couple ways to pass arguments, im not sure whats best,
1939 # but relying on bash 4.4+ escape quoting seems most reliable.
1940 command ssh "${args[@]}" "$remote" \
1941 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
1942 elif [[ ! -t 0 ]]; then
1943 # This case is when commands are being piped to ssh.
1944 # Normally, no bashrc gets sourced.
1945 # But, since we are doing all this, lets source it because we can.
1946 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1947 else
1948 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
1949 fi
1950 else
1951 if [[ -t 0 ]]; then
1952 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
1953 else
1954 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1955 fi
1956 fi
1957 # this function inspired from https://github.com/Russell91/sshrc
1958 }
1959
1960 slr() {
1961 sl --rsync "$@"
1962 }
1963 sss() { # ssh solo
1964 sl -oControlMaster=no -oControlPath=/ "$@"
1965 }
1966 # kill off old shared socket then ssh
1967 ssk() {
1968 m ssh -O exit "$@" || [[ $? == 255 ]]
1969 m sl "$@"
1970 }
1971 ccomp ssh sl slr sss ssk
1972 # plain ssh
1973 ssh() {
1974 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
1975 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
1976 else
1977 LC_USEBASHRC=t command ssh "$@"
1978 fi
1979 }
1980
1981
1982 slog() {
1983 # log with script. timing is $1.t and script is $1.s
1984 # -l to save to ~/typescripts/
1985 # -t to add a timestamp to the filenames
1986 local logdir do_stamp arg_base
1987 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1988 logdir="/a/dt/"
1989 do_stamp=false
1990 while getopts "lt" option
1991 do
1992 case $option in
1993 l ) arg_base=$logdir ;;
1994 t ) do_stamp=true ;;
1995 esac
1996 done
1997 shift $((OPTIND - 1))
1998 arg_base+=$1
1999 [[ -e $logdir ]] || mkdir -p $logdir
2000 $do_stamp && arg_base+=$(date +%F.%T%z)
2001 script -t $arg_base.s 2> $arg_base.t
2002 }
2003 splay() { # script replay
2004 #logRoot="$HOME/typescripts/"
2005 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2006 scriptreplay "$1.t" "$1.s"
2007 }
2008
2009 sr() {
2010 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2011 if [[ $# == 0 ]]; then
2012 sudo -E bash -c -l "$(history -p '!!')"
2013 else
2014 echo this command redos last history item. no argument is accepted
2015 fi
2016 }
2017
2018 srm () {
2019 # with -ll, less secure but faster.
2020 command srm -ll "$@"
2021 }
2022
2023 srun() {
2024 scp $2 $1:/tmp
2025 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
2026 }
2027
2028
2029 swap() {
2030 local tmp
2031 tmp=$(mktemp)
2032 mv $1 $tmp
2033 mv $2 $1
2034 mv $tmp $2
2035 }
2036
2037 tclock() { # terminal clock
2038 local x
2039 clear
2040 date +%l:%_M
2041 len=60
2042 # this goes to full width
2043 #len=${1:-$((COLUMNS -7))}
2044 x=1
2045 while true; do
2046 if (( x == len )); then
2047 end=true
2048 d="$(date +%l:%_M) "
2049 else
2050 end=false
2051 d=$(date +%l:%M:%_S)
2052 fi
2053 echo -en "\r"
2054 echo -n "$d"
2055 for ((i=0; i<x; i++)); do
2056 if (( i % 6 )); then
2057 echo -n _
2058 else
2059 echo -n .
2060 fi
2061 done
2062 if $end; then
2063 echo
2064 x=1
2065 else
2066 x=$((x+1))
2067 fi
2068 sleep 5
2069 done
2070 }
2071
2072
2073 te() {
2074 # test existence / exists
2075 local ret=0
2076 for x in "$@"; do
2077 [[ -e "$x" || -L "$x" ]] || ret=1
2078 done
2079 return $ret
2080 }
2081
2082 psoff() {
2083 # normally, i would just execute these commands in the function.
2084 # however, DEBUG is not inherited, so we need to run it outside a function.
2085 # And we want to run set -x afterwards to avoid spam, so we cram everything
2086 # in here, and then it will run after this function is done.
2087 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
2088 }
2089 pson() {
2090 PROMPT_COMMAND=prompt-command
2091 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2092 trap 'settitle "$BASH_COMMAND"' DEBUG
2093 fi
2094 }
2095
2096 tx() { # toggle set -x, and the prompt so it doesnt spam
2097 if [[ $- == *x* ]]; then
2098 set +x
2099 pson
2100 else
2101 psoff
2102 fi
2103 }
2104
2105 psnetns() {
2106 # show all processes in the network namespace $1.
2107 # blank entries appear to be subprocesses/threads
2108 local x netns
2109 netns=$1
2110 ps -w | head -n 1
2111 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2112 while read -r l; do
2113 x=$(ps -w --no-headers -p $l);
2114 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2115 done
2116 }
2117 nonet() {
2118 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2119 s ip netns add nonet
2120 fi
2121 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2122 }
2123
2124 m() { printf "%s\n" "$*"; "$@"; }
2125
2126 uptime() {
2127 if type -p uprecords &>/dev/null; then
2128 uprecords -B
2129 else
2130 command uptime
2131 fi
2132 }
2133
2134 virshrm() {
2135 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2136 }
2137
2138 vm-set-listen(){
2139 local t
2140 t=$(mktemp)
2141 local vm=$1
2142 local ip=$2
2143 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2144 sed -r "s/listen='[^']+/listen='$ip/"> $t
2145 sudo virsh undefine $vm
2146 sudo virsh define $t
2147 }
2148
2149
2150 vmshare() {
2151 vm-set-listen $1 0.0.0.0
2152 }
2153
2154
2155 vmunshare() {
2156 vm-set-listen $1 127.0.0.1
2157 }
2158
2159 myiwscan() {
2160 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2161 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2162 sudo iw dev wls1 scan | sed -rn "
2163 s/^\Wcapability: (.*)/\1/;Ta;h;b
2164 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2165 # padded to min width of 20
2166 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2167 "|sort -r
2168 }
2169
2170 # * misc stuff
2171
2172
2173 if $use_color && type -p tput &>/dev/null; then
2174 term_bold="$(tput bold)"
2175 term_red="$(tput setaf 1)"
2176 term_green="$(tput setaf 2)"
2177 term_yellow="$(tput setaf 3)"
2178 term_purple="$(tput setaf 5)"
2179 term_nocolor="$(tput sgr0)" # no font attributes
2180
2181 # unused so far. commented for shellcheck
2182 # term_underl="$(tput smul)"
2183 # term_blue="$(tput setaf 4)"
2184 # term_cyan="$(tput setaf 6)"
2185 fi
2186 # Try to keep environment pollution down, EPA loves us.
2187 unset safe_term match_lhs use_color
2188
2189 # * prompt
2190
2191
2192 if [[ $- == *i* ]]; then
2193
2194
2195 case $HOSTNAME in
2196 bk|je|li)
2197 if [[ $EUID == 1000 ]]; then
2198 system-status _ ||:
2199 fi
2200 ;;
2201 esac
2202
2203
2204 # this needs to come before next ps1 stuff
2205 # this stuff needs bash 4, feb 2009,
2206 # old enough to no longer condition on $BASH_VERSION anymore
2207 shopt -s autocd
2208 shopt -s dirspell
2209 PS1='\w'
2210 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2211 PROMPT_DIRTRIM=2
2212 bind -m vi-command B:shell-backward-word
2213 bind -m vi-command W:shell-forward-word
2214 fi
2215
2216 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2217 unset PROMPT_DIRTRIM
2218 PS1="\h:$PS1"
2219 fi
2220
2221 # emacs terminal has problems if this runs slowly,
2222 # so I've thrown a bunch of things at the wall to speed it up.
2223 prompt-command() {
2224 local return=$? # this MUST COME FIRST
2225 local ps_char ps_color
2226 unset IFS
2227
2228 if [[ $HISTFILE ]]; then
2229 history -a # save history
2230 fi
2231
2232 # assigned in brc2
2233 # shellcheck disable=SC1303
2234 if [[ $jr_pid ]]; then
2235 if [[ -e /proc/$jr_pid ]]; then
2236 kill $jr_pid
2237 fi
2238 unset jr_pid
2239 fi
2240
2241 case $return in
2242 0) ps_color="$term_purple"
2243 ps_char='\$'
2244 ;;
2245 *) ps_color="$term_green"
2246 ps_char="$return \\$"
2247 ;;
2248 esac
2249 if [[ ! -O . ]]; then # not owner
2250 if [[ -w . ]]; then # writable
2251 ps_color="$term_bold$term_red"
2252 else
2253 ps_color="$term_bold$term_green"
2254 fi
2255 fi
2256
2257 # faster than sourceing the file im guessing
2258 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2259 eval $(< /dev/shm/iank-status)
2260 fi
2261 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2262 ps_char="@ $ps_char"
2263 fi
2264 # We could test if sudo is active with sudo -nv
2265 # but then we get an email and log of lots of failed sudo commands.
2266 # We could turn those off, but seems better not to.
2267 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2268 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2269 fi
2270 if [[ ! $HISTFILE ]]; then
2271 ps_char="NOHIST $ps_char"
2272 fi
2273 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2274
2275 # set titlebar. instead, using more advanced
2276 # titelbar below
2277 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2278 }
2279 PROMPT_COMMAND=prompt-command
2280
2281 if [[ $TERM == screen* ]]; then
2282 _title_escape="\033]..2;"
2283 else
2284 # somme sites recommend this, i dunno what the diff is.
2285 #_title_escape="\033]30;"
2286 _title_escape="\033]0;"
2287 fi
2288
2289 settitle () {
2290 # this makes it so we show the current command if
2291 # one is running, otherwise, show nothing
2292
2293 if [[ $1 == prompt-command ]]; then
2294 return 0
2295 fi
2296 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2297 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2298 printf "%s" "$*"
2299 echo -ne "\007"
2300 fi
2301 }
2302
2303 # note, this wont work:
2304 # x=$(mktemp); cp a $x
2305 # I havnt figured out why, bigger fish to fry.
2306 #
2307 # for titlebar.
2308 # condition from the screen man page i think.
2309 # note: duplicated in tx()
2310 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2311 trap 'settitle "$BASH_COMMAND"' DEBUG
2312 else
2313 trap DEBUG
2314 fi
2315
2316 fi
2317
2318 # * stuff that makes sense to be at the end
2319
2320
2321 # best practice
2322 unset IFS
2323
2324 # shellcheck disable=SC1090
2325 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2326
2327 # I had this idea to start a bash shell which would run an initial
2328 # command passed through this env variable, then continue on
2329 # interactively. But the use case I had in mind went away.
2330 #
2331 # if [[ $MY_INIT_CMD ]]; then
2332 # "${MY_INIT_CMD[@]}"
2333 # unset MY_INIT_CMD
2334 # fi
2335
2336 # ensure no bad programs appending to this file will have an affect
2337 return 0